## gcin 1.4.6

=== Makefile ===
OPTFLAGS=-g

include config.mak

.SUFFIXES:	.c .o .E .pico .cpp

gcin_tsin_o = tsin.o tsin-util.o win0.o win1.o tsin-parse.o
gcin_pho_o = win-pho.o pho.o pho-util.o pho-sym.o table-update.o pho-dbg.o
gcin_gtab_o = gtab.o win-gtab.o gtab-util.o gtab-list.o gtab-buf.o

GCIN_SO= gcin1.so gcin2.so

OBJS=gcin.o eve.o util.o gcin-conf.o gcin-settings.o locale.o gcin-icon.o \
     gcin-switch.o gcin-exec-script.o $(GCIN_SO) pho-play.o cache.o gtk_bug_fix.o \
     $(gcin_pho_o) $(gcin_gtab_o) gcin-common.o phrase.o t2s-lookup.o gtab-use-count.o

OBJS_TSLEARN=tslearn.o util.o gcin-conf.o pho-util.o tsin-util.o gcin-send.o pho-sym.o \
             table-update.o locale.o gcin-settings.o gcin-common.o gcin-icon.o
OBJS_JUYIN_LEARN=juyin-learn.o locale.o util.o pho-util.o pho-sym.o \
                 gcin-settings.o gcin-conf.o table-update.o pinyin.o gcin-icon.o
OBJS_sim2trad=sim2trad.o util.o gcin2.so locale.o gcin-conf.o gcin-icon.o
OBJS_phod2a=phod2a.o pho-util.o gcin-conf.o pho-sym.o table-update.o pho-dbg.o locale.o \
             gcin-settings.o util.o
OBJS_tsa2d32=tsa2d32.o gcin-send.o util.o pho-sym.o gcin-conf.o locale.o pho-lookup.o
OBJS_phoa2d=phoa2d.o pho-sym.o gcin-send.o gcin-conf.o locale.o pho-lookup.o
OBJS_kbmcv=kbmcv.o pho-sym.o util.o locale.o
OBJS_tsd2a32=tsd2a32.o pho-sym.o pho-dbg.o locale.o util.o
OBJS_gcin2tab=gcin2tab.o gtab-util.o util.o locale.o
OBJS_gtab_merge=gtab-merge.o gtab-util.o util.o locale.o
OBJS_gcin_steup=gcin-setup.o gcin-conf.o util.o gcin-send.o gcin-settings.o \
	gcin-setup-list.o gcin-switch.o locale.o gcin-setup-pho.o about.o \
	gcin-icon.o gcin-setup-gtab.o gtab-list.o gcin-exec-script.o
OBJS_gcin_setup_tab=gcin-setup-tab.o gcin-conf.o util.o gcin-send.o gcin-settings.o \
	gcin-switch.o about.o gcin-icon.o gtab-list.o gcin-exec-script.o

OBJS_gcin_gb_toggle = gcin-gb-toggle.o gcin-conf.o util.o gcin-send.o
OBJS_gcin_kbm_toggle = gcin-kbm-toggle.o gcin-conf.o util.o gcin-send.o
OBJS_gcin_message = gcin-message.o gcin-conf.o util.o gcin-send.o
OBJS_pin_juyin = pin-juyin.o util.o pho-lookup.o locale.o pho-sym.o


#WALL=-Wall
CFLAGS= -DUNIX=1 $(WALL) $(OPTFLAGS) $(GTKINC) -I./IMdkit/include -I./im-client -DDEBUG="0$(GCIN_DEBUG)" \
        -DGCIN_TABLE_DIR=\"$(GCIN_TABLE_DIR)\" \
        -DGCIN_OGG_DIR=\"$(GCIN_OGG_DIR)\" \
        -DDOC_DIR=\"$(DOC_DIR)\" \
        -DGCIN_ICON_DIR=\"$(GCIN_ICON_DIR)\" -DGCIN_VERSION=\"$(GCIN_VERSION)\" \
        -DGCIN_SCRIPT_DIR=\"$(GCIN_SCRIPT_DIR)\" -DGCIN_BIN_DIR=\"$(GCIN_BIN_DIR)\" \
        -DSYS_ICON_DIR=\"$(SYS_ICON_DIR)\" -DFREEBSD=$(FREEBSD) -DMAC_OS=$(MAC_OS) \
        -DG_DISABLE_SINGLE_INCLUDES -DG_DISABLE_DEPRECATED \
        -DGDK_DISABLE_SINGLE_INCLUDES -DGDK_DISABLE_DEPRECATED \
        -DGTK_DISABLE_SINGLE_INCLUDES -DGTK_DISABLE_DEPRECATED
ifeq ($(USE_XIM),Y)
IMdkitLIB = IMdkit/lib/libXimd.a
CFLAGS += -DUSE_XIM=1
OBJS+=IC.o
endif

ifeq ($(MAC_OS),1)
EXTRA_LDFLAGS=-bind_at_load
endif

ifeq ($(USE_TRAY),Y)
CFLAGS += -DTRAY_ENABLED=1
OBJS += tray.o eggtrayicon.o tray-win32.o
endif

ifeq ($(USE_TRAY),N)
GCIN_SO += tray-win32.o
endif

ifeq ($(USE_I18N),Y)
CFLAGS += -DGCIN_i18n_message=1
endif

ifeq ($(USE_TSIN),Y)
CFLAGS += -DUSE_TSIN=1
OBJS += $(gcin_tsin_o)
gcin1_so += tsin-char.pico
endif

ifeq ($(USE_ANTHY),Y)
CFLAGS += -DUSE_ANTHY=1
LDFLAGS += -ldl
ifeq ($(USE_TSIN),N)
OBJS += $(gcin_tsin_o)
endif
endif

ifeq ($(USE_GCB),Y)
CFLAGS += -DUSE_GCB=1
OBJS += gcb.o
endif

OBJ_IMSRV=im-addr.o im-dispatch.o im-srv.o gcin-crypt.o

.c.E:
	$(CC) $(CFLAGS) -E -o $@ $<

.cpp.E:
	$(CCX) $(CFLAGS) -E -o $@ $<

.cpp.o:
	$(CCX) $(CFLAGS) -c $<

.c.pico:
	$(CC) $(CFLAGS) -c -fpic -o $@ $<
.cpp.pico:
	$(CCX) $(CFLAGS) -c -fpic -o $@ $<

PROGS=gcin tsd2a32 tsa2d32 phoa2d phod2a tslearn gcin-setup gcin2tab \
	juyin-learn sim2trad gcin-gb-toggle gcin-message gtab-merge gcin-setup-tab \
	gcin-kbm-toggle
PROGS_SYM=trad2sim
PROGS_CV=kbmcv pin-juyin

all:	$(PROGS) trad2sim $(DATA) $(PROGS_CV) gcin.spec
	$(MAKE) -C data
	$(MAKE) -C gtk-im
ifeq ($(USE_I18N),Y)
	$(MAKE) -C po
endif
	if [ $(QT_IM) = 'Y' ]; then $(MAKE) -C qt-im; fi
	if [ $(QT4_IM) = 'Y' ]; then $(MAKE) -C qt4-im; fi

gcin:   $(OBJS) $(IMdkitLIB) $(OBJ_IMSRV)
	LD_RUN_PATH=$(gcin_ld_run_path) \
	$(CCLD) $(EXTRA_LDFLAGS) -o $@ $(OBJS) $(IMdkitLIB) $(OBJ_IMSRV) -lXtst $(LDFLAGS) -L/usr/X11R6/lib
	rm -f core.*
	ln -sf $@ $@.test

gcin-nocur:   $(OBJS) $(IMdkitLIB) $(OBJ_IMSRV)
	LD_RUN_PATH=$(gcinlibdir) \
	$(CCLD) $(EXTRA_LDFLAGS) -o $@ $(OBJS) $(IMdkitLIB) $(OBJ_IMSRV) -lXtst $(LDFLAGS) -L/usr/X11R6/lib
	rm -f core.*

tslearn:        $(OBJS_TSLEARN)
	export LD_RUN_PATH=$(gcin_ld_run_path) ;\
	$(CCLD) -o $@ $(OBJS_TSLEARN) -L./im-client -lgcin-im-client $(LDFLAGS)

juyin-learn:        $(OBJS_JUYIN_LEARN)
	$(CCLD) -o $@ $(OBJS_JUYIN_LEARN) $(LDFLAGS)
	rm -f core.*
sim2trad:        $(OBJS_sim2trad)
	LD_RUN_PATH=$(gcin_ld_run_path) \
	$(CC) -o $@ $(OBJS_sim2trad) $(LDFLAGS)
	rm -f core.*
trad2sim:	sim2trad
	ln -sf sim2trad trad2sim

gcin-setup:     $(OBJS_gcin_steup) im-client/libgcin-im-client.so
	rm -f core.*
	export LD_RUN_PATH=$(gcin_ld_run_path) ;\
	$(CCLD) -o $@ $(OBJS_gcin_steup) -L./im-client -lgcin-im-client $(LDFLAGS)

gcin-setup-tab: $(OBJS_gcin_setup_tab) im-client/libgcin-im-client.so
	rm -f core.*
	export LD_RUN_PATH=$(gcinlibdir) ;\
	$(CCLD) -o $@ $(OBJS_gcin_setup_tab) -L./im-client -lgcin-im-client $(LDFLAGS)

phoa2d: $(OBJS_phoa2d) im-client/libgcin-im-client.so
	export LD_RUN_PATH=$(gcin_ld_run_path) ;\
	$(CCLD) -o $@ $(OBJS_phoa2d) -L./im-client -lgcin-im-client $(LDFLAGS)

phod2a: $(OBJS_phod2a)
	$(CCLD) -lX11 -o $@ $(OBJS_phod2a) $(LDFLAGS)

tsa2d32:  $(OBJS_tsa2d32) im-client/libgcin-im-client.so
	export LD_RUN_PATH=$(gcin_ld_run_path) ;\
	$(CCLD) -o $@ $(OBJS_tsa2d32) -L./im-client -lgcin-im-client $(LDFLAGS)

tsd2a:  $(OBJS_tsd2a)
	$(CCLD) -o $@ $(OBJS_tsd2a) $(LDFLAGS)

tsd2a32:  $(OBJS_tsd2a32)
	$(CCLD) -o $@ $(OBJS_tsd2a32) $(LDFLAGS)

gcin2tab:  $(OBJS_gcin2tab)
	$(CCLD) -o $@ $(OBJS_gcin2tab) $(LDFLAGS)
	rm -f data/*.gtab

gtab-merge:  $(OBJS_gtab_merge)
	$(CCLD) -o $@ $(OBJS_gtab_merge) $(LDFLAGS)

kbmcv:  $(OBJS_kbmcv)
	$(CCLD) -o $@ $(OBJS_kbmcv) $(LDFLAGS)

gcin-gb-toggle:	$(OBJS_gcin_gb_toggle)
	export LD_RUN_PATH=$(gcin_ld_run_path) ;\
	$(CCLD) -o $@ $(OBJS_gcin_gb_toggle) -L./im-client -lgcin-im-client $(LDFLAGS)

gcin-kbm-toggle:	$(OBJS_gcin_kbm_toggle)
	export LD_RUN_PATH=$(gcin_ld_run_path) ;\
	$(CCLD) -o $@ $(OBJS_gcin_kbm_toggle) -L./im-client -lgcin-im-client $(LDFLAGS)

gcin-message:	$(OBJS_gcin_message)
	export LD_RUN_PATH=$(gcin_ld_run_path) ;\
	$(CCLD) -o $@ $(OBJS_gcin_message) -L./im-client -lgcin-im-client $(LDFLAGS)

pin-juyin:	$(OBJS_pin_juyin)
	$(CCLD) -o $@ $(OBJS_pin_juyin) $(LDFLAGS)

im-client/libgcin-im-client.so:
	$(MAKE) -C im-client

gcin1_so += intcode.pico win-int.pico win-message.pico win-sym.pico \
win-inmd-switch.pico pinyin.pico win-pho-near.pico win-kbm.pico

ifeq ($(USE_ANTHY),Y)
gcin1_so += anthy.pico
endif

gcin1.so: $(gcin1_so) pho.o tsin.o eve.o gtab.o win-sym.o
	$(CCLD) $(SO_FLAGS) -o $@ $(gcin1_so) $(LDFLAGS)

gcin2_so= t2s-lookup.pico
gcin2.so: $(gcin2_so) gcin-conf.o
	$(CCLD) $(SO_FLAGS) -o $@ $(gcin2_so) $(LDFLAGS)

#gtk_bug_fix.so: gtk_bug_fix.pico
#	$(CC) $(SO_FLAGS) -o $@ gtk_bug_fix.pico

### making the following as .so actuall makes the RSS larger
gcin_gtab_so = gtab.pico win-gtab.pico gtab-util.pico
gcin-gtab.so: $(gcin_gtab_so)
	$(CC) $(SO_FLAGS) -o $@  $(gcin_gtab_so) $(LDFLAGS)

gcin_tsin_so = tsin.pico tsin-util.pico win0.pico win1.pico win-pho-near.pico tsin-parse.pico
gcin-tsin.so: $(gcin_tsin_so)
	$(CCLD) -shared -o $@  $(gcin_tsin_so) $(LDFLAGS)

gcin_pho_so=win-pho.pico pho.pico pho-util.pico pho-sym.pico table-update.pico pho-dbg.pico
gcin-pho.so: $(gcin_pho_so)
	$(CC) -shared -fPIC -o $@ $(gcin_pho_so) $(LDFLAGS)

$(IMdkitLIB):
	$(MAKE) -C IMdkit/lib

ibin:	gcin-nocur
	install $(PROGS) $(bindir); \
	cp gcin-nocur $(bindir)/gcin; \
	rm -f $(bindir)/trad2sim; ln -sf sim2trad $(bindir)/trad2sim
	install $(GCIN_SO) $(gcinlibdir)

install:
	install -d $(datadir)/icons
	install -m 644 gcin.png $(datadir)/icons
	$(MAKE) -C icons install
	install -d $(gcinlibdir)
	install $(GCIN_SO) $(gcinlibdir)
	install -d $(bindir)
	$(MAKE) -C data install
	$(MAKE) -C im-client install
	$(MAKE) -C gtk-im install
	if [ $(QT_IM) = 'Y' ]; then $(MAKE) -C qt-im install; fi
	if [ $(QT4_IM) = 'Y' ]; then $(MAKE) -C qt4-im install; fi
	if [ $(prefix) = /usr/local ]; then \
	   install -m 644 gcin.png /usr/share/icons; \
	   install -d $(DOC_DIR); \
	   install -m 644 README.html Changelog.html $(DOC_DIR); \
	   install $(PROGS) $(bindir); \
	   rm -f $(bindir)/trad2sim; ln -sf sim2trad $(bindir)/trad2sim; \
	else \
	   install -d $(DOC_DIR_i); \
	   install -m 644 README.html Changelog.html $(DOC_DIR_i); \
	   install -s $(PROGS) $(bindir); \
	   rm -f $(bindir)/trad2sim; ln -sf sim2trad $(bindir)/trad2sim; \
	fi
	$(MAKE) -C scripts install
	$(MAKE) -C menu install
	$(MAKE) -C man install
ifeq ($(USE_I18N),Y)
	$(MAKE) -C po install
endif
clean:
	$(MAKE) -C IMdkit clean
	$(MAKE) -C data clean
	$(MAKE) -C scripts clean
	$(MAKE) -C im-client clean
	$(MAKE) -C gtk-im clean
	$(MAKE) -C qt-im clean
	$(MAKE) -C qt4-im clean
	$(MAKE) -C man clean
	$(MAKE) -C menu clean
	$(MAKE) -C po clean
	rm -f *.o *.E *.db *.pico *.so config.mak tags $(PROGS) gcin-nocur $(PROGS_CV) \
	$(DATA) .depend gcin.spec trad2sim gcin.spec.tmp gcin.log
	find . '(' -name '.ted*' -o -name '*~' -o -name 'core.*' -o -name 'vgcore.*' ')' -exec rm {} \;

.depend:
	$(CCX) $(CFLAGS) -MM *.cpp > $@

config.mak: VERSION.gcin configure
	./configure

gcin.spec:	gcin.spec.in
	rm -f $@
	sed -e "s/__gcin_version__/$(GCIN_VERSION)/" < $< > $@

include .depend

=== data/Makefile ===
include ../config.mak

.SUFFIXES:	.kbmsrc .kbm .cin .gtab

DATA=pho.tab tsin32.idx \
     cj.gtab ar30.gtab ar30-big.gtab dayi3.gtab pinyin.gtab jyutping.gtab cj5.gtab \
     et.kbm et-asdf.kbm et26.kbm et26-asdf.kbm zo.kbm zo-asdf.kbm \
     pinyin.kbm pinyin-asdf.kbm dvorak.kbm mitac.kbm \
     ibm.kbm tsin32 hsu.kbm pho-huge.tab simplex.gtab symbols.gtab russian.gtab \
     greek.gtab cj-punc.gtab latin-letters.gtab tsin-1.src pin-juyin.xlt \
     t2s.dat s2t.dat
DATAKEEP=symbol-table gtab.list phrase.table phrase-ctrl.table

all:	$(DATA)

tsin32:	tsin.src ../tsa2d32
	GCIN_NO_RELOAD=; export GCIN_NO_RELOAD;export LD_LIBRARY_PATH=../im-client;../tsa2d32 $<

tsin32.idx:	tsin32

pho.tab:	 pho.tab.src ../phoa2d
	GCIN_NO_RELOAD=;export GCIN_NO_RELOAD;export LD_LIBRARY_PATH=../im-client;../phoa2d $<

pho-huge.tab:	 pho-huge.tab.src ../phoa2d
	GCIN_NO_RELOAD=;export GCIN_NO_RELOAD;export LD_LIBRARY_PATH=../im-client;../phoa2d $<

t2s.dat:	t2s-file t2s-file.table
	./t2s-file
s2t.dat:	t2s-file

pin-juyin.xlt:	../pin-juyin pin-juyin.src
	../pin-juyin

extr1:	extr1.c
	$(CC) $< ../util.o ../locale.o -o $@ $(LDFLAGS)

t2s-file:	t2s-file.c
	$(CC) $< ../util.o ../locale.o -o $@ $(LDFLAGS)

tsin-1.src:	extr1
	./extr1 > $@

.cin.gtab:      ../gcin2tab
	../gcin2tab $<

.kbmsrc.kbm:	../kbmcv
	../kbmcv $<

install:
	install -d $(GCIN_TABLE_DIR_i)
	install -m 644 $(DATA) $(DATAKEEP) $(GCIN_TABLE_DIR_i)
#	cd $(GCIN_TABLE_DIR_i); bzip2 -f *.gtab
clean:
	rm -f *~ tags core.* $(DATA) *.gtab extr1 t2s-file tsin-1.src tsin-gtabidx* tsin-ch-idx

=== gtk-im/Makefile ===
include ../config.mak

OBJS = imgcin.o gtkimcontextgcin.o
GTK2IM=gtk-2.0/immodules
IMMODULES=$(libdir)/$(GTK2IM)
IMMODULES_LOCAL=/usr/$(LIB)/$(GTK2IM)


ifeq ($(MAC_OS),1)
EXTRA_INC=-I/sw/include
endif

.SUFFIXES:	.c .o .E
CFLAGS = $(OPTFLAGS) $(EXTRA_INC) $(GTKINC) -I../im-client -I.. \
-I../IMdkit/include -DCLIENT_LIB=1 -DMAC_OS=$(MAC_OS) -DFREEBSD=$(FREEBSD)

ifeq ($(NEW_GTK_IM),Y)
CFLAGS += -DNEW_GTK_IM=1
endif

.c.o:
	$(CC) -c -fPIC $(CFLAGS) -o $@ $<

.c.E:
	$(CC) -E $(CFLAGS) -o $@ $<

all:	im-gcin.so im-gcin-cur.so

im-gcin.so:     $(OBJS) ../im-client/libgcin-im-client.so
	export LD_RUN_PATH=$(gcinlibdir) ;\
	$(CC) $(SO_FLAGS) $(OBJS) -L../im-client -lgcin-im-client -o $@ $(LDFLAGS)
	rm -f core.*

im-gcin-cur.so:     $(OBJS) ../im-client/libgcin-im-client.so
	$(CC) $(SO_FLAGS) $(OBJS) -L../im-client -lgcin-im-client -o $@ $(LDFLAGS)
	rm -f core.*

clean:
	rm -f *.o *.so *~ core.* .depend *.E

install:
	if [ $(prefix) = /usr/local ]; then \
		install -d $(IMMODULES_LOCAL); \
		install -m 755 im-gcin.so $(IMMODULES_LOCAL); \
	else \
		install -d $(IMMODULES); \
		install -m 755 im-gcin.so $(IMMODULES); \
	fi

.depend:
	$(CC) $(CFLAGS) -MM *.c > $@

include .depend

=== im-client/Makefile ===
include ../config.mak

SOFILE=libgcin-im-client.so
SOFILEVER=libgcin-im-client.so.1.2.1

.SUFFIXES:      .c .o .E .cpp
WALL=-Wall
CFLAGS= -DUNIX=1 $(WALL) $(OPTFLAGS) -I. -I.. -I../IMdkit/include $(GTKINC) \
        -DCLIENT_LIB=1 -DGCIN_BIN_DIR=\"$(GCIN_BIN_DIR)\" \
        -DDEBUG="0$(GCIN_DEBUG)" -DGCIN_TABLE_DIR=\"$(GCIN_TABLE_DIR)\" \
        -DFREEBSD=$(FREEBSD) -fPIC
OBJS = gcin-im-client.o im-addr.o gcin-conf.o util.o gcin-crypt-fpic.o

.cpp.E:
	$(CC) $(CFLAGS) -E -o $@ $<

.c.o:
	$(CC) -c $(CFLAGS) $<
.cpp.o:
	$(CC) -x c -c $(CFLAGS) $<

$(SOFILEVER):   $(OBJS)
	$(CC) $(SO_FLAGS) -Wl,-soname,libgcin-im-client.so.1 $(OBJS) -lX11 -o $@
	ln -sf $(SOFILEVER) $(SOFILE)
	ln -sf $(SOFILEVER) $(SOFILE).1
	$(MAKE) -C ../gtk-im

LOCALLIB=/usr/local/$(LIB)

install:
	install -d $(gcinlibdir)
	install -m 755 $(SOFILEVER) $(gcinlibdir)
	cd $(gcinlibdir); rm -f $(SOFILE); ln -s $(SOFILEVER) $(SOFILE); \
	ln -sf $(SOFILEVER) $(SOFILE).1

gcin-conf.o: ../gcin-conf.cpp
	$(CC) -x c -c $(CFLAGS) -o $@ $<

util.o: ../util.cpp
	$(CC) -x c -c $(CFLAGS) -o $@ $<

im-addr.o: ../im-addr.cpp
	$(CC) -x c -c $(CFLAGS) -o $@ $<

gcin-crypt-fpic.o: ../gcin-crypt.cpp
	$(CC) -x c -c $(CFLAGS) -o $@ $<

clean:
	rm -f *.o *.so *.so.* *~ *.E *.db config.mak tags core.* .depend

.depend:
	$(CC) $(CFLAGS) -MM *.cpp > $@

include .depend

=== man/Makefile ===
include ../config.mak

clean:
	rm -f *~
install:
	install -d $(man1dir)
	install -m 444  gcin-gb-toggle.1 \
			gcin-kbm-toggle.1 \
			gcin-message.1 \
			gcin-setup.1 \
			gcin.1 \
			gcin2tab.1 \
			gtab-merge.1 \
			juyin-learn.1 \
			phoa2d.1 \
			sim2trad.1 \
			tsa2d32.1 \
			tslearn.1 \
			$(man1dir)

=== menu/Makefile ===
MENUS = gcin gcin-setup

include ../config.mak

all:

install:
	if [ $(prefix) = /usr/local ]; then \
           install gcin-setup.desktop $(GCIN_SETUP_DESKTOP); \
	   install gcin-setup.desktop /usr/share/applications; \
	   install -d /usr/lib/menu; \
	   install -m 644 $(MENUS) /usr/lib/menu; \
	   which update-menus > /dev/null 2>&1 && update-menus || exit 0; \
	else \
	   install -d $(libdir)/menu; \
	   install -m 644 $(MENUS) $(libdir)/menu; \
	   install -d $(GCIN_SETUP_DESKTOP_rpm); \
	   install -m 644 gcin-setup.desktop $(GCIN_SETUP_DESKTOP_rpm); \
	   install -d $(datadir)/applications; \
	   install -m 644 gcin-setup.desktop $(datadir)/applications; \
	fi
clean:
	rm -f $(MENUS) *~

=== qt-im/Makefile ===
include ../config.mak
QT=qt3
QTIM=$(QT)/plugins/inputmethods
IMMODULES=$(libdir)/$(QTIM)
INCS=-I../im-client -I/usr/include `pkg-config --cflags qt-mt` -I/usr/include/Xft2/X11/Xft  -I/usr/include/fontconfig -I/usr/include/freetype2
CXXFLAGS=$(OPTFLAGS) $(INCS) -Wall -D_REENTRANT -fPIC  -DQT_THREAD_SUPPORT -DQT_PLUGIN -DQT_SHARED -DQT_NO_DEBUG
OBJS=qgcininputcontextplugin.o qgcininputcontextplugin_my.o qgcininputcontext.o qgcininputcontext_x11.o
.SUFFIXES:	.c .cpp .a .so .E .h
LDFLAGS=-L../im-client -lgcin-im-client -Wl,-rpath,$(gcinlibdir)
all:	libqgcin.so

.cpp.E:
	$(CXX) -E $(CFLAGS) $(INCS) $< > $@
.h.o:
	/usr/lib/$(QT)/bin/moc $< -o $<_moc.cpp
	$(CXX) -c -pipe $(CXXFLAGS) $(INCS) $<_moc.cpp -o $@

libqgcin.so: $(OBJS)
	export LD_RUN_PATH=$(gcinlibdir) ;\
	$(CXX) -fno-exceptions -shared -o $@ $(OBJS) $(LDFLAGS)
	rm -f core.*
install:
	if [ $(prefix) = /usr/local ]; then \
		install -d $(DESTDIR)/$(QT_IM_DIR); \
		install -m 755 libqgcin.so $(DESTDIR)/$(QT_IM_DIR); \
	else \
		install -d $(IMMODULES); \
                install -m 755 libqgcin.so $(IMMODULES); \
	fi
clean:
	rm -f $(OBJS) libqgcin.so *~ core.* *moc*.cpp *.E

=== qt4-im/Makefile ===
include ../config.mak
QT=qt4
QTIM=$(QT)/plugins/inputmethods
IMMODULES=$(libdir)/$(QTIM)

INCS=-I../im-client -I/usr/include/X11 `pkg-config QtCore QtGui --cflags`
CXXFLAGS=$(OPTFLAGS) $(INCS) -Wall -D_REENTRANT -fPIC  -DQT4 -DQT_SHARED \
-DQT_IMMODULE -DPIC
OBJS= moc_gcin-qt.o gcin-qt.o im-gcin-qt.o gcin-imcontext-qt.o
.SUFFIXES:	.c .cpp .a .so .E .h
LDFLAGS=-L../im-client -lgcin-im-client -Wl,-rpath,$(gcinlibdir)
all:    im-gcin.so

.cpp.E:
	$(CXX) -E $(CFLAGS) $(INCS) $< > $@

moc_gcin-qt.cpp:	gcin-qt.h
	/usr/lib/$(QT)/bin/moc $< -o moc_gcin-qt.cpp

im-gcin.so: $(OBJS)
	export LD_RUN_PATH=$(gcinlibdir) ;\
	$(CXX) -fno-exceptions -shared -o $@ $(OBJS) $(LDFLAGS)
	rm -f core.*
install:
	if [ $(prefix) = /usr/local ]; then \
		install -d $(DESTDIR)/$(QT4_IM_DIR); \
		install -m 755 im-gcin.so $(DESTDIR)/$(QT4_IM_DIR); \
	else \
		install -d $(IMMODULES); \
                install -m 755 im-gcin.so $(IMMODULES); \
	fi
clean:
	rm -f $(OBJS) im-gcin.so *~ core.* *moc*.cpp *.E .depend

.depend:
	$(CXX) $(CXXFLAGS) -MM *.cpp > $@

include .depend

=== scripts/Makefile ===
include ../config.mak

SCRIPTS=gcin-user-setup modify-XIM utf8-edit noseeing-inst gtab.append_prepare html-browser

all:	$(SCRIPTS)

install:
	if [ $(prefix) = /usr/local ]; then \
	   sh modify-XIM; \
	fi
	install -d $(GCIN_SCRIPT_DIR_i)
	install -m 755 $(SCRIPTS) $(GCIN_SCRIPT_DIR_i)
clean:
	rm -f *~ tags core.*

=== debian/changelog ===
gcin (1.4.6-3) unstable; urgency=low

  * Fix FTBFS with gtk2 2.20 due to deprecated Gtk+ macros. (Closes: #577377)
  * Bump libgtk2.0-dev build-deps to 2.20.0.
  * Disable --new_gtk_im. Too unstable with mozilla browser.
  * Add back README.html.
  * Update im-switch script also checks qt4 path.
  * Update Maintainer, Vcs-Git and Vcs-Browser. Migrating to DD account.

 -- Kan-Ru Chen <koster@debian.org>  Wed, 05 May 2010 00:20:58 +0800

gcin (1.4.6-2) unstable; urgency=low

  * Fix FTBFS with gtk2 2.19 due to deprecated Gtk+ macros
    GTK_WIDGET_APP_PAINTABLE and GTK_WIDGET_NO_WINDOW. (Closes: #569246)
    (LP: #520148)
  * Updated Standards-Version to 3.8.4, no changes needed.

 -- Kan-Ru Chen <koster@debian.org.tw>  Sat, 27 Feb 2010 17:24:34 +0800

gcin (1.4.6-1) unstable; urgency=low

  * New upstream release
    This version fixed FTBFS with binutils-gold. (Closes: #554417)
  * Switched to dpkg-source 3.0 (quilt) format
  * Use modern debhelper style
  * Updated Standards-Version to 3.8.3
  * Updated copyright information
  * Acknowledge NMU - Thanks Stefano

 -- Kan-Ru Chen <koster@debian.org.tw>  Sun, 10 Jan 2010 16:49:29 +0800

gcin (1.4.5-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Add missing #include to fix FTBFS with gcc 4.4, patch by Martin
    Michlmayr. (Closes: #531715)
  * gcin-qt{3,4}-immodule: add lintian overrides for shlib-defines-rpath,
    this is needed to get the package pass through auto-REJECT. Rationale:
    rpath is appropriate here, the packages use private shlibs.

 -- Stefano Zacchiroli <zack@debian.org>  Sat, 26 Dec 2009 10:13:19 +0100

gcin (1.4.5-1) unstable; urgency=low

  * New Upstream Version
  * Wrokaround dh_gtkmodules bug.
  * Bump Standards-Versions to 3.8.1, no changes needed.

 -- Kanru Chen <koster@debian.org.tw>  Tue, 12 May 2009 11:35:18 +0800

gcin (1.4.5~pre2-1) unstable; urgency=low

  * [811fc3b] New Upstream version 1.4.5.pre2
  * [86b0996] Update patches.
              - fix_gdm_crash_498619.diff: Dropped, fixed up stream.  
              - fix_QT_detection.diff: Split into two patches.
              - fix_anthy_error_message.diff: Added.
  * [dfa7a85] Enable anthy.

 -- Kanru Chen <koster@debian.org.tw>  Tue, 03 Mar 2009 14:33:40 +0800

gcin (1.4.2-2) unstable; urgency=low

  * Upload to unstable
  * [ef36b0e] New maintainer (Closes: #505501)
  * [4861a1e] Replace dh_clean -k with dh_prep.
  * [5b60cca] Add Vcs-Git and Vcs-Browser field.
  * [5dafdd8] Add README.source
  * [63892e6] Add patch ld_only_link_needed.diff
  * [a848d1e] Fix the bug causing gdm crashes. (Closes: #498619)
  * [326815b] Update patch descriptions.

 -- Kanru Chen <koster@debian.org.tw>  Sat, 06 Dec 2008 14:58:33 +0800

gcin (1.4.2-1) experimental; urgency=low

  * New upstream release
  * New package gcin-dev
  * Make gcin-qt3-immodule a versionised dependency on gcin
  * Drop fix_desktop_file_categories.diff because upstream has merged it
  * Bump Standards-Versions to 3.8.0

 -- Wen-Yen Chuang <caleb@calno.com>  Thu,  1 Aug 2008 18:45:44 +0800

gcin (1.4.0-1) unstable; urgency=low

  * New upstream release
    This release fixes FTBFS on ia64 architecture. (Closes: #480520)
  * Update copyright information
  * Migrate from dpatch to quilt
    Drop 20_fix-manpages.dpatch and 40_fix_FTBFS_on_sparc_hppa_ia64.dpatch
    because upstream has merged them.
  * Install AUTHORS file to /usr/share/doc/gcin

 -- Wen-Yen Chuang <caleb@calno.com>  Tue, 20 May 2008 14:57:12 +0800

gcin (1.3.9-1) unstable; urgency=low

  * New upstream release
  * Update symlinks for new manpages
  * Enable i18n
  * Refresh 10_fix-directory-structure.dpatch
  * Add 20_fix-manpages.dpatch to prevent lintian warnings
  * Include /usr/share/dpatch/dpatch.make to make debian/rules simpler
  * Add Depends ${misc:Depends} for gcin-qt3-immodule

 -- Wen-Yen Chuang <caleb@calno.com>  Wed,  7 May 2008 21:39:20 +0800

gcin (1.3.4-3) unstable; urgency=low

  * Fix FTBFS on hppa, ia64, and sparc architectures (Closes: #406036)
  * Disable binary stripping in upstream's Makefile (Closes: #436914)
  * Auto-detect GTK+ module ABI version (Closes: #419366, #420504)
  * Update debian/copyright to machine-readable format
  * Make libgcin-im-client.so a private library
  * Bump Standards-Version to 3.7.3
  * Fix typos in package description
  * Clean up debian/rules
  * Make lintian quiet
    - set Build-Depends libgtk2.0-dev >= 2.10.1
    - move Homepage in package description to source stanza
    - replace all "GTK" with "GTK+" in package descriptions
    - replace all "##DP" with "## DP:" in debian/patches/*
    - update debian/gcin.menu
    - add 50_fix-desktop-file-categories.dpatch to match latest .desktop file
      policy
    - do not use -$(MAKE) in debian/rules so that other error messages from the
      clean rule will still be caught

 -- Wen-Yen Chuang <caleb@calno.com>  Sun, 27 Apr 2008 15:32:36 +0800

gcin (1.3.4-2) unstable; urgency=low

  The "Nobuta power! Cyuunyuu!" Release.

  * Update for GTK+ 2.10. (Closes: #419293)
  * debian/control:
    - bump up the libgtk2.0-dev build-dep to >= 2.10.1-1.
    - remove dependency for libgtk2.0-bin
  * debian/gcin.postinst:
    debian/gcin.postrm:
    - remove update-gtk-immodules
  * debian/rules:
    - call dh_gtkmodules with LD_LIBRARY_PATH.
    - remove scripts for GTK+ version detection.

 -- Wen-Yen Chuang <caleb@calno.com>  Sun, 15 Apr 2007 00:42:03 +0800

gcin (1.3.4-1) unstable; urgency=low

  The "Maki Horikita" Release.

  * New upstream release.
  * debian/patches:
    - modify 10_fix-directory-structure.dpatch to cope with upstream's
      changes.
    - modify 30_disable_rpath_for_gtk-im.dpatch to prevent fuzz during patching.

 -- Wen-Yen Chuang <caleb@calno.com>  Tue, 10 Apr 2007 21:42:40 +0800

gcin (1.3.3-2) unstable; urgency=low

  * Move from experimental to unstable.
    This version(1.3.3) has fixed FTBFS on GNU/kFreeBSD. (Closes: #414406)

 -- Wen-Yen Chuang <caleb@calno.com>  Mon,  9 Apr 2007 01:44:27 +0800



=== debian/control ===
Source: gcin
Section: utils
Priority: optional
Maintainer: Kan-Ru Chen <koster@debian.org>
Homepage: http://www.csie.nctu.edu.tw/~cp76/gcin/
Vcs-Git: git://git.debian.org/git/users/koster/gcin.git
Vcs-Browser: http://git.debian.org/?p=users/koster/gcin.git;a=summary
Build-Depends: debhelper (>= 7.0.50~), libgtk2.0-dev (>= 2.20.0), libxtst-dev, libqt3-mt-dev, libqt4-dev, libanthy-dev
Standards-Version: 3.8.4

Package: gcin
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: gcin-qt3-immodule, im-switch, anthy
Description: an GTK+ based input method platform for Chinese users
 Gcin is an input method platform, which supports GTK+/QT immodule and XIM.
 Gcin is focused mainly on Traditional Chinese. However, it is also very useful
 for Simplified Chinese, Japanese, and many other languages.
 .
 Input method table format of gcin is almost as same as those of xcin and scim.
 .
 This package contains an GTK+ immodule. If you want to use QT immodule, please
 install gcin-qt3-immodule package.

Package: gcin-dev
Section: devel
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}, gcin (>= ${source:Version})
Conflicts: gcin (<< 1.4.2)
Description: an GTK+ based input method platform - development files
 Gcin is an input method platform, which supports GTK+/QT immodule and XIM.
 Gcin is focused mainly on Traditional Chinese. However, it is also very useful
 for Simplified Chinese, Japanese, and many other languages.
 .
 This package provides header files of gcin.

Package: gcin-qt3-immodule
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, gcin (>= ${source:Version})
Description: an QT3 input method module with gcin as backend
 Gcin is an input method platform, which supports GTK+/QT immodule and XIM.
 Gcin is focused mainly on Traditional Chinese. However, it is also very useful
 for Simplified Chinese, Japanese, and many other languages.
 .
 This package is the QT 3.x native input method module for gcin.

Package: gcin-qt4-immodule
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, gcin (>= ${source:Version})
Description: an QT4 input method module with gcin as backend
 Gcin is an input method platform, which supports GTK+/QT immodule and XIM.
 Gcin is focused mainly on Traditional Chinese. However, it is also very useful
 for Simplified Chinese, Japanese, and many other languages.
 .
 This package is the QT 4.x native input method module for gcin.

=== debian/rules ===
#!/usr/bin/make -f

GTKVER = $(shell pkg-config --variable=gtk_binary_version gtk+-2.0)

%:
	dh $@

override_dh_auto_configure:
	./configure --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) --prefix=/usr --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info CFLAGS="$(CFLAGS)"  \
	--use_i18n=Y \
	--use_qt3=Y

override_dh_auto_clean:
	make clean

override_dh_auto_install:
	$(MAKE) install DESTDIR=$(CURDIR)/debian/tmp
	mkdir -p debian/gcin/usr/lib/gtk-2.0/$(GTKVER)/immodules
	mv debian/tmp/usr/lib/gtk-2.0/immodules/* debian/gcin/usr/lib/gtk-2.0/$(GTKVER)/immodules/
	mkdir -p debian/gcin/usr/lib/gtk-2.0/$(GTKVER)/immodule-files.d
	sed -e s,@GTKVER@,$(GTKVER), debian/gcin.immodules.in > debian/gcin/usr/lib/gtk-2.0/$(GTKVER)/immodule-files.d/gcin.immodules

override_dh_installchangelogs:
	dh_installchangelogs Changelog.html

override_dh_makeshlibs:
	dh_makeshlibs -n

override_dh_shlibdeps:
	LD_LIBRARY_PATH=debian/gcin/usr/lib/gcin:$(LD_LIBRARY_PATH) dh_shlibdeps

=== debian/watch ===
version=3
http://cle.linux.org.tw/gcin/download/gcin-(.*)\.tar\.bz2

## gcin 1.5.8

=== Makefile ===
--- 
+++ 
@@ -12,39 +12,41 @@
 
 OBJS=gcin.o eve.o util.o gcin-conf.o gcin-settings.o locale.o gcin-icon.o \
      gcin-switch.o gcin-exec-script.o $(GCIN_SO) pho-play.o cache.o gtk_bug_fix.o \
-     $(gcin_pho_o) $(gcin_gtab_o) gcin-common.o phrase.o t2s-lookup.o gtab-use-count.o
+     $(gcin_pho_o) $(gcin_gtab_o) gcin-common.o phrase.o t2s-lookup.o gtab-use-count.o \
+     win-save-phrase.o unix-exec.o pho-kbm-name.o statistic.o
 
 OBJS_TSLEARN=tslearn.o util.o gcin-conf.o pho-util.o tsin-util.o gcin-send.o pho-sym.o \
-             table-update.o locale.o gcin-settings.o gcin-common.o gcin-icon.o
+             table-update.o locale.o gcin-settings.o gcin-common.o gcin-icon.o pho-dbg.o
 OBJS_JUYIN_LEARN=juyin-learn.o locale.o util.o pho-util.o pho-sym.o \
-                 gcin-settings.o gcin-conf.o table-update.o pinyin.o gcin-icon.o
+                 gcin-settings.o gcin-conf.o table-update.o pinyin.o gcin-icon.o pho-dbg.o
 OBJS_sim2trad=sim2trad.o util.o gcin2.so locale.o gcin-conf.o gcin-icon.o
 OBJS_phod2a=phod2a.o pho-util.o gcin-conf.o pho-sym.o table-update.o pho-dbg.o locale.o \
              gcin-settings.o util.o
 OBJS_tsa2d32=tsa2d32.o gcin-send.o util.o pho-sym.o gcin-conf.o locale.o pho-lookup.o
-OBJS_phoa2d=phoa2d.o pho-sym.o gcin-send.o gcin-conf.o locale.o pho-lookup.o
+OBJS_phoa2d=phoa2d.o pho-sym.o gcin-send.o gcin-conf.o locale.o pho-lookup.o util.o
 OBJS_kbmcv=kbmcv.o pho-sym.o util.o locale.o
-OBJS_tsd2a32=tsd2a32.o pho-sym.o pho-dbg.o locale.o util.o
+OBJS_tsd2a32=tsd2a32.o pho-sym.o pho-dbg.o locale.o util.o gtab-dbg.o
 OBJS_gcin2tab=gcin2tab.o gtab-util.o util.o locale.o
 OBJS_gtab_merge=gtab-merge.o gtab-util.o util.o locale.o
 OBJS_gcin_steup=gcin-setup.o gcin-conf.o util.o gcin-send.o gcin-settings.o \
 	gcin-setup-list.o gcin-switch.o locale.o gcin-setup-pho.o about.o \
-	gcin-icon.o gcin-setup-gtab.o gtab-list.o gcin-exec-script.o
-OBJS_gcin_setup_tab=gcin-setup-tab.o gcin-conf.o util.o gcin-send.o gcin-settings.o \
-	gcin-switch.o about.o gcin-icon.o gtab-list.o gcin-exec-script.o
+	gcin-icon.o gcin-setup-gtab.o gtab-list.o gcin-exec-script.o pho-kbm-name.o
 
 OBJS_gcin_gb_toggle = gcin-gb-toggle.o gcin-conf.o util.o gcin-send.o
 OBJS_gcin_kbm_toggle = gcin-kbm-toggle.o gcin-conf.o util.o gcin-send.o
+OBJS_gcin_exit = gcin-exit.o gcin-conf.o util.o gcin-send.o
 OBJS_gcin_message = gcin-message.o gcin-conf.o util.o gcin-send.o
 OBJS_pin_juyin = pin-juyin.o util.o pho-lookup.o locale.o pho-sym.o
 
+OBJS_tsin2gtab_phrase = tsin2gtab-phrase.o gcin-conf.o util.o locale.o \
+	pho-dbg.o pho-sym.o gtab-dbg.o
 
 #WALL=-Wall
 CFLAGS= -DUNIX=1 $(WALL) $(OPTFLAGS) $(GTKINC) -I./IMdkit/include -I./im-client -DDEBUG="0$(GCIN_DEBUG)" \
         -DGCIN_TABLE_DIR=\"$(GCIN_TABLE_DIR)\" \
         -DGCIN_OGG_DIR=\"$(GCIN_OGG_DIR)\" \
         -DDOC_DIR=\"$(DOC_DIR)\" \
-        -DGCIN_ICON_DIR=\"$(GCIN_ICON_DIR)\" -DGCIN_VERSION=\"$(GCIN_VERSION)\" \
+        -DGCIN_ICON_DIR=\"$(GCIN_ICON_DIR)\" \
         -DGCIN_SCRIPT_DIR=\"$(GCIN_SCRIPT_DIR)\" -DGCIN_BIN_DIR=\"$(GCIN_BIN_DIR)\" \
         -DSYS_ICON_DIR=\"$(SYS_ICON_DIR)\" -DFREEBSD=$(FREEBSD) -DMAC_OS=$(MAC_OS) \
         -DG_DISABLE_SINGLE_INCLUDES -DG_DISABLE_DEPRECATED \
@@ -76,7 +78,6 @@
 ifeq ($(USE_TSIN),Y)
 CFLAGS += -DUSE_TSIN=1
 OBJS += $(gcin_tsin_o)
-gcin1_so += tsin-char.pico
 endif
 
 ifeq ($(USE_ANTHY),Y)
@@ -109,8 +110,8 @@
 	$(CCX) $(CFLAGS) -c -fpic -o $@ $<
 
 PROGS=gcin tsd2a32 tsa2d32 phoa2d phod2a tslearn gcin-setup gcin2tab \
-	juyin-learn sim2trad gcin-gb-toggle gcin-message gtab-merge gcin-setup-tab \
-	gcin-kbm-toggle
+	juyin-learn sim2trad gcin-gb-toggle gcin-message gtab-merge \
+	gcin-kbm-toggle tsin2gtab-phrase gcin-exit
 PROGS_SYM=trad2sim
 PROGS_CV=kbmcv pin-juyin
 
@@ -120,54 +121,45 @@
 ifeq ($(USE_I18N),Y)
 	$(MAKE) -C po
 endif
+	if [ $(GTK3_IM) = 'Y' ]; then $(MAKE) -C gtk3-im; fi
 	if [ $(QT_IM) = 'Y' ]; then $(MAKE) -C qt-im; fi
 	if [ $(QT4_IM) = 'Y' ]; then $(MAKE) -C qt4-im; fi
 
+#gcc_ld_run_path=-Wl,-rpath,$(gcin_ld_run_path)
+
 gcin:   $(OBJS) $(IMdkitLIB) $(OBJ_IMSRV)
-	LD_RUN_PATH=$(gcin_ld_run_path) \
-	$(CCLD) $(EXTRA_LDFLAGS) -o $@ $(OBJS) $(IMdkitLIB) $(OBJ_IMSRV) -lXtst $(LDFLAGS) -L/usr/X11R6/lib
+	$(CCLD) $(EXTRA_LDFLAGS) $(gcc_ld_run_path) -o $@ $(OBJS) $(IMdkitLIB) $(OBJ_IMSRV) -lXtst $(LDFLAGS) -L/usr/X11R6/lib
+	rm -f core.* vgcore.*
+	ln -sf $@ $@.test
+
+gcin-nocur:   $(OBJS) $(IMdkitLIB) $(OBJ_IMSRV)
+	$(CCLD) -Wl,-rpath,$(gcinlibdir) $(EXTRA_LDFLAGS) -o $@ $(OBJS) $(IMdkitLIB) $(OBJ_IMSRV) -lXtst $(LDFLAGS) -L/usr/X11R6/lib
 	rm -f core.*
-	ln -sf $@ $@.test
-
-gcin-nocur:   $(OBJS) $(IMdkitLIB) $(OBJ_IMSRV)
-	LD_RUN_PATH=$(gcinlibdir) \
-	$(CCLD) $(EXTRA_LDFLAGS) -o $@ $(OBJS) $(IMdkitLIB) $(OBJ_IMSRV) -lXtst $(LDFLAGS) -L/usr/X11R6/lib
-	rm -f core.*
 
 tslearn:        $(OBJS_TSLEARN)
-	export LD_RUN_PATH=$(gcin_ld_run_path) ;\
-	$(CCLD) -o $@ $(OBJS_TSLEARN) -L./im-client -lgcin-im-client $(LDFLAGS)
+	$(CCLD) $(gcc_ld_run_path) -o $@ $(OBJS_TSLEARN) -L./im-client -lgcin-im-client $(LDFLAGS)
 
 juyin-learn:        $(OBJS_JUYIN_LEARN)
 	$(CCLD) -o $@ $(OBJS_JUYIN_LEARN) $(LDFLAGS)
 	rm -f core.*
 sim2trad:        $(OBJS_sim2trad)
-	LD_RUN_PATH=$(gcin_ld_run_path) \
-	$(CC) -o $@ $(OBJS_sim2trad) $(LDFLAGS)
+	$(CC) $(gcc_ld_run_path) -o $@ $(OBJS_sim2trad) $(LDFLAGS)
 	rm -f core.*
 trad2sim:	sim2trad
 	ln -sf sim2trad trad2sim
 
 gcin-setup:     $(OBJS_gcin_steup) im-client/libgcin-im-client.so
 	rm -f core.*
-	export LD_RUN_PATH=$(gcin_ld_run_path) ;\
-	$(CCLD) -o $@ $(OBJS_gcin_steup) -L./im-client -lgcin-im-client $(LDFLAGS)
-
-gcin-setup-tab: $(OBJS_gcin_setup_tab) im-client/libgcin-im-client.so
-	rm -f core.*
-	export LD_RUN_PATH=$(gcinlibdir) ;\
-	$(CCLD) -o $@ $(OBJS_gcin_setup_tab) -L./im-client -lgcin-im-client $(LDFLAGS)
+	$(CCLD) $(gcc_ld_run_path) -o $@ $(OBJS_gcin_steup) -L./im-client -lgcin-im-client $(LDFLAGS)
 
 phoa2d: $(OBJS_phoa2d) im-client/libgcin-im-client.so
-	export LD_RUN_PATH=$(gcin_ld_run_path) ;\
-	$(CCLD) -o $@ $(OBJS_phoa2d) -L./im-client -lgcin-im-client $(LDFLAGS)
+	$(CCLD) $(gcc_ld_run_path) -o $@ $(OBJS_phoa2d) -L./im-client -lgcin-im-client $(LDFLAGS)
 
 phod2a: $(OBJS_phod2a)
 	$(CCLD) -lX11 -o $@ $(OBJS_phod2a) $(LDFLAGS)
 
 tsa2d32:  $(OBJS_tsa2d32) im-client/libgcin-im-client.so
-	export LD_RUN_PATH=$(gcin_ld_run_path) ;\
-	$(CCLD) -o $@ $(OBJS_tsa2d32) -L./im-client -lgcin-im-client $(LDFLAGS)
+	$(CCLD) $(gcc_ld_run_path) -o $@ $(OBJS_tsa2d32) -L./im-client -lgcin-im-client $(LDFLAGS)
 
 tsd2a:  $(OBJS_tsd2a)
 	$(CCLD) -o $@ $(OBJS_tsd2a) $(LDFLAGS)
@@ -186,22 +178,28 @@
 	$(CCLD) -o $@ $(OBJS_kbmcv) $(LDFLAGS)
 
 gcin-gb-toggle:	$(OBJS_gcin_gb_toggle)
-	export LD_RUN_PATH=$(gcin_ld_run_path) ;\
-	$(CCLD) -o $@ $(OBJS_gcin_gb_toggle) -L./im-client -lgcin-im-client $(LDFLAGS)
+	$(CCLD) $(gcc_ld_run_path) -o $@ $(OBJS_gcin_gb_toggle) -L./im-client -lgcin-im-client $(LDFLAGS)
 
 gcin-kbm-toggle:	$(OBJS_gcin_kbm_toggle)
-	export LD_RUN_PATH=$(gcin_ld_run_path) ;\
-	$(CCLD) -o $@ $(OBJS_gcin_kbm_toggle) -L./im-client -lgcin-im-client $(LDFLAGS)
+	$(CCLD) $(gcc_ld_run_path) -o $@ $(OBJS_gcin_kbm_toggle) -L./im-client -lgcin-im-client $(LDFLAGS)
+
+gcin-exit:	$(OBJS_gcin_exit)
+	$(CCLD) $(gcc_ld_run_path) -o $@ $(OBJS_gcin_exit) -L./im-client -lgcin-im-client $(LDFLAGS)
 
 gcin-message:	$(OBJS_gcin_message)
-	export LD_RUN_PATH=$(gcin_ld_run_path) ;\
-	$(CCLD) -o $@ $(OBJS_gcin_message) -L./im-client -lgcin-im-client $(LDFLAGS)
+	$(CCLD) $(gcc_ld_run_path) -o $@ $(OBJS_gcin_message) -L./im-client -lgcin-im-client $(LDFLAGS)
 
 pin-juyin:	$(OBJS_pin_juyin)
 	$(CCLD) -o $@ $(OBJS_pin_juyin) $(LDFLAGS)
 
+tsin2gtab-phrase:       $(OBJS_tsin2gtab_phrase)
+	$(CCLD) -o $@ $(OBJS_tsin2gtab_phrase) $(LDFLAGS)
+
 im-client/libgcin-im-client.so:
 	$(MAKE) -C im-client
+
+gcin-version.h:	VERSION.gcin
+	echo '#define GCIN_VERSION "'`cat VERSION.gcin`'"' > gcin-version.h
 
 gcin1_so += intcode.pico win-int.pico win-message.pico win-sym.pico \
 win-inmd-switch.pico pinyin.pico win-pho-near.pico win-kbm.pico
@@ -252,6 +250,7 @@
 	$(MAKE) -C data install
 	$(MAKE) -C im-client install
 	$(MAKE) -C gtk-im install
+	if [ $(GTK3_IM) = 'Y' ]; then $(MAKE) -C gtk3-im install; fi
 	if [ $(QT_IM) = 'Y' ]; then $(MAKE) -C qt-im install; fi
 	if [ $(QT4_IM) = 'Y' ]; then $(MAKE) -C qt4-im install; fi
 	if [ $(prefix) = /usr/local ]; then \
@@ -278,6 +277,9 @@
 	$(MAKE) -C scripts clean
 	$(MAKE) -C im-client clean
 	$(MAKE) -C gtk-im clean
+ifeq ($(GTK3_IM), Y)
+	$(MAKE) -C gtk3-im clean
+endif
 	$(MAKE) -C qt-im clean
 	$(MAKE) -C qt4-im clean
 	$(MAKE) -C man clean

=== data/Makefile ===
include ../config.mak

.SUFFIXES:	.kbmsrc .kbm .cin .gtab
CFLAGS= -DUNIX=1 $(WALL) $(OPTFLAGS) $(GTKINC) -I.. -DDEBUG="0$(GCIN_DEBUG)" \


DATA=pho.tab2 tsin32.idx \
     cj.gtab ar30.gtab ar30-big.gtab dayi3.gtab pinyin.gtab jyutping.gtab cj5.gtab \
     et.kbm et26.kbm zo.kbm pinyin.kbm dvorak.kbm mitac.kbm \
     ibm.kbm tsin32 hsu.kbm pho-huge.tab2 simplex.gtab symbols.gtab russian.gtab \
     greek.gtab cj-punc.gtab latin-letters.gtab tsin-1.src pin-juyin.xlt \
     t2s.dat s2t.dat cj543.gtab
DATAKEEP=symbol-table gtab.list phrase.table phrase-ctrl.table

all:	$(DATA)

tsin32:	tsin.src ../tsa2d32
	GCIN_NO_RELOAD=; export GCIN_NO_RELOAD;export LD_LIBRARY_PATH=../im-client;../tsa2d32 $<

tsin32.idx:	tsin32

pho.tab2:	 pho.tab2.src ../phoa2d
	GCIN_NO_RELOAD=;export GCIN_NO_RELOAD;export LD_LIBRARY_PATH=../im-client;../phoa2d $<

pho-huge.tab2:	 pho-huge.tab2.src ../phoa2d
	GCIN_NO_RELOAD=;export GCIN_NO_RELOAD;export LD_LIBRARY_PATH=../im-client;../phoa2d $<

t2s.dat:	t2s-file t2s-file.table
	./t2s-file
s2t.dat:	t2s-file

pin-juyin.xlt:	../pin-juyin pin-juyin.src
	../pin-juyin

extr1:	extr1.c
	$(CC) $(CFLAGS) $< ../util.o ../locale.o -o $@ $(LDFLAGS)

t2s-file:	t2s-file.c
	$(CC) $(CFLAGS) $< ../util.o ../locale.o -o $@ $(LDFLAGS)

tsin-1.src:	extr1
	./extr1 > $@

.cin.gtab:      ../gcin2tab
	../gcin2tab $<

.kbmsrc.kbm:	../kbmcv
	../kbmcv $<

install:
	install -d $(GCIN_TABLE_DIR_i)
	install -m 644 $(DATA) $(DATAKEEP) $(GCIN_TABLE_DIR_i)
#	cd $(GCIN_TABLE_DIR_i); bzip2 -f *.gtab
clean:
	rm -f *~ tags core.* $(DATA) *.gtab extr1 t2s-file tsin-1.src tsin-gtabidx* tsin-ch-idx

=== qt-im/Makefile ===
--- 
+++ 
@@ -3,10 +3,10 @@
 QTIM=$(QT)/plugins/inputmethods
 IMMODULES=$(libdir)/$(QTIM)
 INCS=-I../im-client -I/usr/include `pkg-config --cflags qt-mt` -I/usr/include/Xft2/X11/Xft  -I/usr/include/fontconfig -I/usr/include/freetype2
-CXXFLAGS=$(OPTFLAGS) $(INCS) -Wall -D_REENTRANT -fPIC  -DQT_THREAD_SUPPORT -DQT_PLUGIN -DQT_SHARED -DQT_NO_DEBUG
+CXXFLAGS=$(OPTFLAGS) $(INCS) -Wall -D_REENTRANT -DUNIX=1 -fPIC  -DQT_THREAD_SUPPORT -DQT_PLUGIN -DQT_SHARED -DQT_NO_DEBUG
 OBJS=qgcininputcontextplugin.o qgcininputcontextplugin_my.o qgcininputcontext.o qgcininputcontext_x11.o
 .SUFFIXES:	.c .cpp .a .so .E .h
-LDFLAGS=-L../im-client -lgcin-im-client -Wl,-rpath,$(gcinlibdir)
+LDFLAGS=-L../im-client -lgcin-im-client -Wl,-rpath,$(gcinlibdir) `pkg-config qt-mt --libs`
 all:	libqgcin.so
 
 .cpp.E:
@@ -16,8 +16,7 @@
 	$(CXX) -c -pipe $(CXXFLAGS) $(INCS) $<_moc.cpp -o $@
 
 libqgcin.so: $(OBJS)
-	export LD_RUN_PATH=$(gcinlibdir) ;\
-	$(CXX) -fno-exceptions -shared -o $@ $(OBJS) $(LDFLAGS)
+	$(CXX) $(gcc_ld_run_path) -fno-exceptions -shared -o $@ $(OBJS) $(LDFLAGS)
 	rm -f core.*
 install:
 	if [ $(prefix) = /usr/local ]; then \

=== debian/changelog ===
gcin (1.5.8-1) unstable; urgency=low

  * New upstream release.
  * Stop build Qt3 immodule. (Closes: #604350)
  * debian/gcin-ext.1: merged upstream.
  * debian/patches/008_add_shebang_to_scripts.diff: merged.
  * debian/patches/009_add_tsin2gtab_phrase_manpage.diff: merged.

 -- Kan-Ru Chen <koster@debian.org>  Mon, 28 Feb 2011 15:35:50 +0800

gcin (1.5.7~pre13-1) experimental; urgency=low

  * New snapshot.
  * Update debian/watch to match debian version scheme.

 -- Kan-Ru Chen <koster@debian.org>  Tue, 30 Nov 2010 10:44:06 +0800

gcin (1.5.7~pre12-1) experimental; urgency=low

  * New snapshot.
  * Refresh patches.
  * debian/patches/008_add_shebang_to_scripts.diff,
    debian/patches/009_add_tsin2gtab_phrase_manpage.diff: New.
  * debian/gcin-exit.1: New.
  * Updated Standards-Version to 3.9.1, no changes needed.
  
 -- Kan-Ru Chen <koster@debian.org>  Mon, 29 Nov 2010 22:06:56 +0800

=== debian/control ===
--- 
+++ 
@@ -5,13 +5,13 @@
 Homepage: http://www.csie.nctu.edu.tw/~cp76/gcin/
 Vcs-Git: git://git.debian.org/git/users/koster/gcin.git
 Vcs-Browser: http://git.debian.org/?p=users/koster/gcin.git;a=summary
-Build-Depends: debhelper (>= 7.0.50~), libgtk2.0-dev (>= 2.20.0), libxtst-dev, libqt3-mt-dev, libqt4-dev, libanthy-dev
-Standards-Version: 3.8.4
+Build-Depends: debhelper (>= 7.0.50~), libgtk2.0-dev (>= 2.20.0), libxtst-dev, libqt4-dev, libanthy-dev
+Standards-Version: 3.9.1
 
 Package: gcin
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Recommends: gcin-qt3-immodule, im-switch, anthy
+Recommends: im-switch | im-config, gcin-qt4-immodule, anthy
 Description: an GTK+ based input method platform for Chinese users
  Gcin is an input method platform, which supports GTK+/QT immodule and XIM.
  Gcin is focused mainly on Traditional Chinese. However, it is also very useful
@@ -34,16 +34,6 @@
  .
  This package provides header files of gcin.
 
-Package: gcin-qt3-immodule
-Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, gcin (>= ${source:Version})
-Description: an QT3 input method module with gcin as backend
- Gcin is an input method platform, which supports GTK+/QT immodule and XIM.
- Gcin is focused mainly on Traditional Chinese. However, it is also very useful
- for Simplified Chinese, Japanese, and many other languages.
- .
- This package is the QT 3.x native input method module for gcin.
-
 Package: gcin-qt4-immodule
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, gcin (>= ${source:Version})

=== debian/rules ===
--- 
+++ 
@@ -7,8 +7,7 @@
 
 override_dh_auto_configure:
 	./configure --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) --prefix=/usr --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info CFLAGS="$(CFLAGS)"  \
-	--use_i18n=Y \
-	--use_qt3=Y
+	--use_i18n=Y
 
 override_dh_auto_clean:
 	make clean
